# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# include "apm.h"
# include "apmUtil.h"
# include "apmPrint.h" /* DO_ROUND, LEFT_JUST */

# define  DEBUG		NO

/* Variables private to this file */
static APM	u_scratch = NULL ;
static char	buf[BUF_SZ], trunc_buf[BUF_SZ], mant_str[DBL_DIGITS+3] ; 
/* +++++++++++++++++++++++++++++ */

double 
apmtodbl (APM ap)
{
     apmConvert( buf, BUF_SZ, DBL_DIGITS, DO_ROUND, LEFT_JUST, ap ) ;
     return( atof( buf ) ) ;
}
/* ++++++++++++++++++++++++++++ */

void 
dbltoapm (APM apnum, int base, double dbl)
{
    int    exponent ;
    char   *dpt, *ept ;

    buf[0] = '\0' ;
    sprintf( buf, "%.14e", dbl ) ;

    ept = strchr( buf, 'e' ) ;
    dpt = strchr( buf, '.' ) ;
    if( (ept == NULL) || (dpt == NULL) ){
		fprintf( stderr, "Bad double in dbltoapm(). Died. \n" ) ;
		exit( 1 ) ;
    }
    
    *ept = *dpt = '\0' ;

    sprintf( mant_str, "%s%s", buf, (dpt+1) ) ;
    exponent = atoi( ept + 1 ) - strlen( dpt + 1 ) ;

	if( u_scratch == NULL ) { u_scratch = apmNew( base ) ; }
    apmAssignString( u_scratch, mant_str, base ) ;
    apmScale( apnum, u_scratch, exponent ) ;
}
/* ++++++++++++++++++++++++++ */

void 
apmTruncate (APM x, int dp)
{
    apmConvert( trunc_buf, BUF_SZ, (short)dp, DO_ROUND, LEFT_JUST, x ) ;
#if DEBUG
    printf( "apmTruncate : x = %s \n", trunc_buf ) ;
# endif
    apmAssignString( x, trunc_buf, x->base ) ;
}
