# include <stdio.h>
# include <string.h>

/* Variables shared through converse.h */
int    optind = 1, opterr = 1 ;
char   *optarg ;
/* +++++++++++++++++++++++ */

char 
getopt (int argc, char *argv[], char *opt_str)
{
    int    j ;
    char   *opt_pt ;

    for( j=optind ; j < argc ; j++ ) {
	/*
		If the argument seems to be part of a command-line
		option, do something.
	*/
		if( argv[j][0] == '-' ) {
	/* 	
		Take "--" as the end of the argument list. 
	*/
			if( argv[j][1] == '-' )  
				return( EOF ) ;
			else {
	/*	
		Look for the option in the string of recognized options 
	*/
				opt_pt = strchr( opt_str, argv[j][1] ) ;
		/*
			Print an error message if the argument was an unrecognized
			option.
		*/

				if( (opt_pt == NULL) && (opterr != 0) ) {
					fprintf( stderr, 
						 "Unrecognized option : -%c. \n", 
								argv[j][1] ) ;
				}
		/*
			If the option has an argument, deal with it.
		*/
				else {
					if( opt_pt[1] == ':' ) {
						if( argv[j][2] != '\0' ) {
							optarg = argv[j] + 2 ;
							optind = j + 1 ;
						}
						else {
							optind = j + 2 ;
							optarg = argv[j+1] ;
						}
					}
					else {
						optind = j + 1 ;
						optarg = NULL ;
					}

					return( *opt_pt ) ;
				}
			}
		}
    }

    return( EOF ) ;
}
		    
